part of masamune_local_messaging;

class LocalMessagingCore {
  LocalMessagingCore._();

  static LocalMessagingModel get _messaging {
    return readProvider(localeMessagingProvider);
  }

  static Future<LocalMessagingModel> initialize({
    String androidDefaultIcon = "@mipmap/ic_launcher",
  }) async {
    return _messaging.initialize(
      androidDefaultIcon: androidDefaultIcon,
    );
  }

  static Future<void> send({
    required String topic,
    required String title,
    required String text,
    String androidChannelId = "defaultChannel",
    String androidChannelName = "Default Channel",
  }) async {
    return _messaging.send(
      topic: topic,
      title: title,
      text: text,
      androidChannelId: androidChannelId,
      androidChannelName: androidChannelName,
    );
  }

  static Future<void> schedule({
    required String topic,
    required String title,
    required String text,
    required DateTime dateTime,
    MessagingScheduleRepeatType repeatType = MessagingScheduleRepeatType.none,
    String androidChannelId = "defaultChannel",
    String androidChannelName = "Default Channel",
  }) async {
    return _messaging.schedule(
      topic: topic,
      title: title,
      text: text,
      dateTime: dateTime,
      androidChannelId: androidChannelId,
      androidChannelName: androidChannelName,
    );
  }

  static Future<void> cancelSchedule(
    String topic,
  ) async {
    return _messaging.cancelSchedule(
      topic,
    );
  }

  static Future<void> cancelAllSchedule() async {
    return _messaging.cancelAllSchedule();
  }
}
